<?php  // ランキング表示（学習者用）
session_start();
include("../param.inc");

/**
 *	得点順にソートする関数
 *	@param $val1 回答データ1
 *	@param $val2 回答データ2
 *	@return 比較結果（1,0,-1)
 */
function sort_by_ranking($val1, $val2) {
	$v1 = explode(",", $val1);
	$v2 = explode(",", $val2);
	if ($v1[2] > $v2[2]) return -1;
	else if ($v1[2] == $v2[2]) {
		if ($v1[5] > $v2[5]) return 1;
		else if ($v1[5] == $v2[5]) return 0;
		else return -1;
	} else return 1;
}

/**
 *	全員の成績を表示
 *	@param $path 成績保存フォルダ
 */
function show_allscore_ranking($path) {
	$n = count($_SESSION['no']);   //  ユーザ数
	$data = NULL;
	for ($i=0; $i<$n; $i++) {
		$scorefile = "$path/" . $_SESSION['uid'][$i];
		if (file_exists($scorefile)) {
			$fp = fopen($scorefile, "r");
//			while ($tmp = fgets($fp, 4096)) $data[] = $tmp;  // 成績を取り込む
			$data[] = fgets($fp, 4096);  // 最初の成績だけを取り込む
			fclose($fp);
		}
	}
	$n = count($data);
	if ($n > 0) {  // 成績があれば
		// $data を得点順にソート
		usort($data, "sort_by_ranking");

		// 成績表を表示 
		print("<TABLE border=1><TR><TH>Rank</TH><TH>Name</TH><TH>Score</TH><TH>Questions</TH><TH>Date answered</TH><TH>Time used (second)</TH>\n");
		$val = explode(",", $data[0]); // カンマで分割
		$j = count($val);
		for ($i=6; $i < $j-1; $i=$i+2)  // 問題番号を出力
		print("<TH>" . ($i-4)/2 . "</TH>");
		print("</TR>\n");
		for ($i = 0,$ranking=1; $i < $n; $i++,$ranking++) {
			$val = explode(",", $data[$i]); // カンマで分割
			print("<TR><TD align='center'>$ranking</TD><TD>");
			if ($val[1] == $_SESSION['user'])     // 自分の成績なら名前を表示
			print("<FONT color='blue'>$val[1]</FONT>");
			else print("********");
			print("</TD><TD align='center'>$val[2]</TD><TD align='center'>$val[3]</TD><TD>$val[4]</TD><TD align='right'>$val[5]</TD>\n");
			for ($k = 6; $k< $j-1; $k=$k+2) {
				print("<TD align='center'>" . $val[$k]);  // 生徒の解答
				if ($val[$k+1] == "○") // 正解
				print("<BR><FONT color='BLUE'>○</FONT></TD>");
				else                    // 間違い
				print("<BR><FONT color='RED'>×</FONT></TD>");
			}
			print("</TR>\n");
		}
		print("</TABLE>\n");
	} else print_error("No score record.");
}

print_header("Quiz");
if (!isset($_SESSION['id']) || ($_SESSION['id'] == "")) { // ログインしていない
	print("<SCRIPT language='JavaScript'>");
	print("window.alert('Please login first.');");
	print("</SCRIPT>");
	print("<CENTER><A href='../main/index.php'>To login page</A></CENTER>");
} else {
	print_headline("Post-deadline grade list (ordered by score) ");
	?>
Score will be shown in the descend order.<BR>
Even if the quiz is taken multiple times, only the first result will be ranked.
<BR>
If there are same score records, the one with quicker answer time will be above.

<FORM method="POST" action="quiz_ranking.php">
<CENTER><?php
print_title1("Older score list (ordered by score)");

$path = 0;
for ($i=1; $i<=20; $i++) {
	$x = "q" . $i;
	if (is_dir($x)) {
		if (isset($_POST[$x])) $path = $i;
		print('<INPUT type="submit" value="No.' . $i . '" name="' .$x. '">　');
	}
}
if ($path > 0) {
	print("<H4>No. $path</H4>\n");
	show_allscore_ranking("q". $path);
}
?></CENTER>
</FORM>
<?php
} print_copyright();
?>

</BODY>
</HTML>
