<?php
session_start();
include("../param.inc");

/**
 *	得点順にソート
 *	@param $val1  データ1
 *	@param $val2  データ2
 *	@return 比較結果（1,0,-1）
 */
function sort_by_ranking($val1, $val2) {
	$v1 = explode(",", $val1);
	$v2 = explode(",", $val2);
	if ($v1[2] > $v2[2]) return -1;
	else if ($v1[2] == $v2[2]) {
		if ($v1[5] > $v2[5]) return 1;
		else if ($v1[5] == $v2[5]) return 0;
		else return -1;
	} else return 1;
}

/**
 *	全員の成績を表示
 *	@param $path 成績保存フォルダ
 */
function save_allscore_ranking($path) {
	$n = count($_SESSION['no']);   //  ユーザ数
	$data = NULL;
	for ($i=0; $i<$n; $i++) {
		$scorefile = "$path/" . $_SESSION['uid'][$i];
		if (file_exists($scorefile)) {
			$fp = fopen($scorefile, "r");
//			while ($tmp = fgets($fp, 4096)) $data[] = $tmp;  // 成績を取り込む
			$data[] = fgets($fp, 4096); // 最初の成績だけを取り込む
			fclose($fp);
		}
	}
	$n = count($data);
	if ($n > 0) {  // 成績があれば
		// $data を得点順にソート
		usort($data, "sort_by_ranking");
		if (isset($_POST[$path])) {  // 保存ボタンが押されたら
			$fp = fopen($path . "/tmp_ranking.csv", "w");
			$header = "No. , Name, Score, Questions, Date answered, Time used (s),";
			$val = explode(",", $data[0]); // カンマで分割
			$j = count($val);
			for ($i=6; $i < $j-1; $i=$i+2)  // 問題番号を出力
			$header = $header . ($i-4)/2 . ",,";
			$header = $header . "\n";
			fputs($fp, mb_convert_encoding($header,"SJIS","auto"));
			for ($i = 0; $i<$n; $i++)
			fputs($fp, mb_convert_encoding($data[$i],"SJIS","auto"));
			fclose($fp);
			print('<DIV align="right">Download：<A href="' . $path . '/tmp_ranking.csv">Score file</A></DIV>' . "\n");
		}
		// 成績表を表示 
		print("<TABLE border=1><TR><TH>Rank</TH><TH>No.</TH><TH>Name</TH><TH>Score</TH><TH>Questions</TH><TH>Date answered</TH><TH>Time used (s)</TH>\n");
		$val = explode(",", $data[0]); // カンマで分割
		$j = count($val);
		for ($i=6; $i < $j-1; $i=$i+2)  // 問題番号を出力
		print("<TH>" . ($i-4)/2 . "</TH>");
		print("</TR>\n");
		for ($i = 0,$ranking=1; $i < $n; $i++,$ranking++) {
			$val = explode(",", $data[$i]); // カンマで分割
			print("<TR><TD align='center'>$ranking</TD><TD align='center'>$val[0]</TD><TD>$val[1]</TD><TD align='center'>$val[2]</TD><TD align='center'>$val[3]</TD><TD>$val[4]</TD><TD align='right'>$val[5]</TD>\n");
			for ($k = 6; $k< $j-1; $k=$k+2) {
				print("<TD align='center'>" . $val[$k]);  // 生徒の解答
				if ($val[$k+1] == "○") // 正解
				print("<BR><FONT color='BLUE'>○</FONT></TD>");
				else                    // 間違い
				print("<BR><FONT color='RED'>×</FONT></TD>");
			}
			print("</TR>\n");
		}
		print("</TABLE>\n");
	} else print_error("No score record.");
}

print_header("Quiz");
if (!isset($_SESSION['id']) || ($_SESSION['id'] == "")) { // ログインしていない
	print("<SCRIPT language='JavaScript'>");
	print("window.alert('Please login first.');");
	print("</SCRIPT>");
	print("<CENTER><A href='../main/index.php'>To login page</A></CENTER>");
} else if ($_SESSION['admin']==0) { // 管理者でない
	print("<SCRIPT language='JavaScript'>");
	print("window.alert('You are not an administrator.');");
	print("</SCRIPT>");
} else {
	print_headline("Score file save path after the deadline");
	?>
q?/tmp_ranking.csv file will be created upon clicking the button below.
<BR>
For example, q1/tmp_ranking.csv is a file for quiz no.1 score file (order by score).
<BR>
Even if the quiz is taken multiple times, only the first result will be ranked.
<BR>
<FORM method="POST" action="score_ranking.php">
<CENTER><?php
print_title1("Older score (order by score)");

$path = 0;
for ($i=1; $i<=20; $i++) {
	$x = "q" . $i;
	if (is_dir($x)) {
		if (isset($_POST[$x])) $path = $i;
		print('<INPUT type="submit" value="No.' . $i . '" name="' .$x. '">　');
	}
}
if ($path > 0) {
	print("<H4>No. $path</H4>\n");
	save_allscore_ranking("q". $path);
}
?></CENTER>
</FORM>
<?php
} print_copyright();
?>

</BODY>
</HTML>
